commit 106110289c2021edb9fd6ffae4945fedbbd43d7b
Author: freddy77 <freddy77>
Date:   Mon Feb 8 09:48:08 2010 +0000

    fix some memory problems

diff --git a/ChangeLog b/ChangeLog
index bddf737..4599d6e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Feb  8 10:46:55 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/config.c: fix some memory problems
+
 Sun Feb  7 16:50:58 EST 2010	JK Lowden <jklowden@freetds.org>
 	* doc/userguide.sgml preparing for release
 	* src/apps/bsqlodbc.c use hdesc to detmine octet count
@@ -2298,4 +2301,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2984 2010/02/07 21:55:48 jklowden Exp $
+$Id: ChangeLog,v 1.2985 2010/02/08 09:48:08 freddy77 Exp $
diff --git a/src/tds/config.c b/src/tds/config.c
index 678f35a..4b81e64 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -80,7 +80,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.158 2010/02/07 21:56:10 jklowden Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.159 2010/02/08 09:48:09 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -380,7 +380,9 @@ tds_read_conf_file(TDSCONNECTION * connection, const char *server)
 static int
 tds_read_conf_sections(FILE * in, const char *server, TDSCONNECTION * connection)
 {
-	TDSCONNECTION defaults;
+	DSTR default_instance;
+	int default_port;
+
 	int found;
 
 	tds_read_conf_section(in, "global", tds_parse_conf_section, connection);
@@ -388,21 +390,25 @@ tds_read_conf_sections(FILE * in, const char *server, TDSCONNECTION * connection
 	if (!server[0])
 		return 0;
 	rewind(in);
-	defaults = *connection;
+
+	tds_dstr_init(&default_instance);
+	tds_dstr_dup(&default_instance, &connection->instance_name);
+	default_port = connection->port;
 
 	found = tds_read_conf_section(in, server, tds_parse_conf_section, connection);
-	
+
 	/* 
 	 * If both instance and port are specified and neither one came from the default, it's an error 
 	 * TODO: If port/instance is specified in the non-default, it has priority over the default setting. 
 	 * TODO: test this. 
 	 */
-	if (!tds_dstr_isempty(&connection->instance_name) && connection->port && 
-	  !(!tds_dstr_isempty(   &defaults.instance_name) ||    defaults.port)) {
+	if (!tds_dstr_isempty(&connection->instance_name) && connection->port &&
+	    !(!tds_dstr_isempty(&default_instance) || default_port)) {
 		tdsdump_log(TDS_DBG_ERROR, "error: cannot specify both port %d and instance %s.\n", 
 						connection->port, tds_dstr_cstr(&connection->instance_name));
 		/* tdserror(tds->tds_ctx, tds, TDSEPORTINSTANCE, 0); */
 	}
+	tds_dstr_free(&default_instance);
 	return found;
 }
 

